blob: 080eb63d341fbac81cc5d9cf0300a01ee76648a5 [file] [log] [blame]
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -04001#!/bin/bash
2# This file is meant to be SOURCED
3#
4# Copyright 2016 RIFT.IO Inc
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
18# container_funcs
19# 24 June 2016 -- Jeremy Mordkoff -- Genesis
20
21print_stack() {
22 local i
23 local stack_size=${#FUNCNAME[1]}
24 echo "BACKTRACE:" >&2
25 for (( i=1; i<$stack_size ; i++ )); do
26 local func="${FUNCNAME[$i]}"
27 [ x$func = x ] && func=MAIN
28 local linen="${BASH_LINENO[(( i - 1 ))]}"
29 local src="${BASH_SOURCE[$i]}"
30 [ x"$src" = x ] && src=non_file_source
31 echo "### $func $src $linen" >&2
32 done
33 echo "-------" >&2
34}
35
36
garciadeblas4d89c372021-11-25 11:57:18 +010037FATAL_TRACK() {
38 echo -e "\n### $(date) ${FUNCNAME[1]}: FATAL error: $*" >&2
39 track end fatal $1 "'${@:2}'" none
40 print_stack
41 exit 1
42}
43
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -040044FATAL() {
Jeremy Mordkoff35d6f242016-10-06 16:17:05 -070045 echo -e "\n### $(date) ${FUNCNAME[1]}: FATAL error: $*" >&2
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -040046 print_stack
47 exit 1
48}
49
50WARNING() {
Jeremy Mordkoff35d6f242016-10-06 16:17:05 -070051 echo -e "\n### $(date) ${FUNCNAME[1]}: WARNING error: $*" >&2
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -040052}
53
54INFO() {
garciadeblas0bc87522021-10-20 22:16:17 +020055 echo "## $(date) ${FUNCNAME[1]}: INFO: $*" >&2
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -040056}
57
58DEBUG() {
garciadeblas0bc87522021-10-20 22:16:17 +020059 echo "# $(date) ${FUNCNAME[1]}: DEBUG: $*" >&2
Jeremy Mordkoff50c2e862016-06-24 15:26:41 -040060}
Jeremy Mordkoff35d6f242016-10-06 16:17:05 -070061
62CMD() {
63 echo "# executing '$*' ..."
64 "$@"
65 rc=$?
66 echo "# .... '$*' done RC was $rc"
67 return $rc
68}